say "Welcome to your dynamic grade document to keep track of the grades of your students"
say "Press enter if you want to start"
parse pull startKey

/* Excel Part */
/*Making an Excel document*/
excelApplication = .OLEObject~NEW("Excel.Application")
excelApplication~visible = .true
Worksheet= excelApplication~Workbooks~Add~Worksheets[1]
saveDocument = "C:\grades\gradedocument.xlsx"


say "What is the name of the subject you want to grade?"
parse pull name_subject

say "What is the class you want to grade?"
parse pull name_class


/*Asking for number of students and number of grades and save that into a variable*/

say "How many students do you have?"
PARSE PULL student_number


 /*saving "names into column A1"*/                              
Worksheet~range(A||1)~value = "Names"
Worksheet~range(A||1)~font~bold = .true
Worksheet~range(A||1)~interior~colorIndex = 42 
Worksheet~range(A||1)~columnWidth = 25

/*asking for names of students, saving them into excel sheet and into stem variables*/
do line = 2 to student_number +1 
    say "What is your name of your" line-1  "student?"
    parse pull name	 
    cell = Worksheet~range(A||line)                   
	cell~value = name        
    cell~font~bold = .true 
	cell~interior~colorIndex = 7          
	cell~columnWidth = 25
end


/*directly accessing names from excel sheet*/
arrayStudentNames = .array ~new
do e = 2 to student_number +1 
    schuler = (Worksheet~range(A||e)~value)~makeString
    arrayStudentNames[e-1] = schuler
END

say "How many grades do you have?"
PARSE PULL grade_count

/*Making grades headers in excel*/
colTitle = "ABCDEFGHIJKLMNOPQRS"
do col = 1 to grade_count
    colLetter = colTitle~substr(col+1,1)
    cell = Worksheet~range(colLetter||1)
	cell~value = "Grade" col        
    cell~font~bold = .true 
	cell~interior~colorIndex = 42          
	cell~columnWidth = 25
end

/*making after the grades a column with the Grades*/
poscolGrade = colTitle~substr(grade_count+2,1)
cell = Worksheet~range(poscolGrade||1)
cell~value = "Final grade" col        
cell~font~bold = .true 
cell~interior~colorIndex = 42          
cell~columnWidth = 25


/*putting grades in excel table*/
do a = 1 to student_number
    do nr = 1 to grade_count
        say "What is the" nr" grade from your "a" Student?"
        PARSE PULL gradee
	    posGrades = colTitle~substr(nr+1,1)
        cell = Worksheet~range(posGrades||a+1)
        cell~value = gradee
        
        /*und vlt die Noten dann in jedes Array reinspeichern*/		
        cell~font~bold = .true           
        cell~columnWidth = 25
    end
end





/*Determining column Position of final grades*/
colLes = colTitle~substr(grade_count+2,1)


/*Determing the mean of the grades*/
do y = 2 to student_number +1
    summeNoten = 0
    do anz = 1 to grade_count
        colLe = colTitle~substr(anz+1,1)
        x = Worksheet~range(colLe||y)~value
	    summeNoten = summeNoten + x
	END
	endnote = summeNoten/grade_count 
	
/*selecting the final grade based on mean of grades*/
    SELECT     
        WHEN endnote < 1.5 THEN DO
	        Worksheet~range(colLes||y)~value = "1"
            Worksheet~range(colLes||y)~interior~colorIndex = 4			
	    END;
        WHEN endnote >= 1.5 & endnote < 2.5 THEN DO
	        Worksheet~range(colLes||y)~value = "2"
            Worksheet~range(colLes||y)~interior~colorIndex = 4			
        END;
        WHEN endnote >= 2.5 & endnote < 3.5 THEN DO
	        Worksheet~range(colLes||y)~value = "3"
			Worksheet~range(colLes||y)~interior~colorIndex = 4
	    END;
	    WHEN endnote >= 3.5 & endnote < 4.5 THEN DO
	        Worksheet~range(colLes||y)~value = "4"
			Worksheet~range(colLes||y)~interior~colorIndex = 4
	    END;
        OTHERWISE DO
	        Worksheet~range(colLes||y)~value = "5"
			Worksheet~range(colLes||y)~interior~colorIndex = 4
        END;
    END		
END


/*accessing final grades from excel sheet*/
arrayFinalGrades = .array ~new
do w = 2 to student_number +1 
    gradess = (Worksheet~range(poscolGrade||w)~value)~makeString
    arrayFinalGrades[w-1] = gradess
END

Worksheet~SaveAs(saveDocument)

/*word part*/

/*creating word*/
Word = .OLEObject~New("Word.Application")
Word~visible=.true
say "Now a word Document will be created so you can save the end grades of the studdents in them"

NewDoc= Word~Documents~Add
say "Now the word is open. Let's now save the end grades in them"


Selection=Word~Selection
/*putting name of subject and name of class as a header in word*/
Selection~TypeText("Grades of: ")
Selection~TypeText(name_subject)
Selection~TypeText(" from class: ")
Selection~TypeText(name_class)
Selection~TypeParagraph

/*determine position of final grade*/
posfina = colTitle~substr(grade_count+2,1)

/*take final grade from excel sheet and student names that were saved in a stem variable and save it in word*/
do z = 2 to student_number +1
    Selection~TypeText("Name: ")
    Selection~TypeText(arrayStudentNames[z-1])
    Selection~TypeText(" , ")
    Selection~TypeText("Final Grade: ")
    Selection~TypeText(arrayFinalGrades[z-1])
    Selection~TypeParagraph
	
end


/*Formatting text*/
Selection~WholeStory
Font=Selection~Font
Font~Name="NewRoman"
Font~Size="16"
Font~Bold=.True

/*saving the document*/
FileNameWord = "C:\grades\finalgrades"
NewDoc~SaveAs(FileNameWord)


/*CURL PART*/

say "Do you want some tips on how to motivate your students? yes/no"
parse pull answer
if answer = "yes" then
DO
    command="curl https://www.nbpts.org/blog/top-5-strategies-for-motivating-students/"
    outArr=.array~new -- array for stdout
    errArr=.array~new -- array for stderr: curl's information goes here
    ADDRESS SYSTEM command WITH OUTPUT USING (outArr) ERROR USING (errArr)
    source=outArr~makeString -- turn array into string
    parse var source '</h4>' . '<p><strong>1.' tip1 '</strong></p>'
    parse var source '</h4>' . '<p><strong>2.' tip2 '</strong></p>'
    parse var source '</h4>' . '<p><strong>3.' tip3 '</strong></p>'
    parse var source '</h4>' . '<p><strong>4.' tip4 '</strong></p>'
    parse var source '</h4>' . '<p><strong>5.' tip5 '</strong></p>'
    say "Tip 1: " tip1
    say "Tip 2: " tip2
    say "Tip 3: " tip3
    say "Tip 4: " tip4
    say "Tip 5: " tip5
END
if answer = "no" then 
DO
    say "alright, so have a nice day then!"
END
parse pull a












